"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
function createHistory(config) {
    if (!config.states) {
        return undefined;
    }
    var history = {};
    Object.keys(config.states).forEach(function (stateId) {
        var state = config.states[stateId];
        if (!state.states) {
            return;
        }
        history[stateId] = createHistory(state);
    });
    history.$current = config.initial;
    return history;
}
exports.createHistory = createHistory;
function updateHistory(history, stateValue) {
    var nextHistory = __assign({}, history, { $current: stateValue });
    if (typeof stateValue === 'string') {
        return nextHistory;
    }
    Object.keys(stateValue).forEach(function (subStatePath) {
        var subHistory = history[subStatePath];
        var subStateValue = stateValue[subStatePath];
        if (typeof subHistory === 'string') {
            // this will never happen, just making TS happy
            return;
        }
        nextHistory[subStatePath] = updateHistory(subHistory, subStateValue);
    });
    return nextHistory;
}
exports.updateHistory = updateHistory;
